--
--
--

return function()
	return {
		state = false,
		awake = function(self)
			self.parent.y = self.parent.y - 8

			if self.parent.state == "closed" then
				self.parent.animation:setAnimation "active"
				self.parent.physics.collides = true
			elseif self.parent.state == "opened" then
				self.parent.animation:setAnimation "inactive"
				self.parent.physics.collides = false
			end

			self.state = game:machine{
				initial = self.parent.state,
				events = {
					{name = "open", from = "closed", to = "opened"},
					{name = "close", from = "opened", to = "closed"}
				},
				callbacks = {
					onopen = function(self, event, to, from, parent)
						local lc = game.context
						game.context = parent
						parent.physics.collides = false
						parent.physics.blocksBall = false

						play_animation "deactivate"
						set_animation "inactive"

						game.context = lc
					end,
					onclose = function(self, event, to, from, parent)
						local lc = game.context
						game.context = parent
						parent.physics.collides = true
						parent.physics.blocksBall = false

						play_animation "activate"
						set_animation "active"

						game.context = lc
					end
				}
			}
		end,
		doesExplode = function(self)
			return false
		end,
		onBellRing = function(self, bell)
			print "ring"
			if self.state.current == "opened" then
				self.state:close(self.parent)
			else
				self.state:open(self.parent)
			end
		end
	}
end
