--
--
--
--
--

return function()
	return {
		age = 0,
		colors = {"Red", "Orange", "Yellow", "Green", "Blue", "Purple"},
		color = 1,
		awake = function(self)

		end,
		update = function(self, dt, speed)
			local hb = self.parent.sprite.slices.hitbox.frames[self.parent.animation.index].bounds
			self.age = self.age + (dt * speed)
			if self.age > 0.05 then
				self.age = 0
				self.color = self.color + 1
				if self.color == #self.colors then
					self.color = 1
				end

			end

			self.parent.sprite.color = self.colors[self.color]

			self.parent.physics.width = hb.w
			self.parent.physics.height = hb.h
			self.parent.physics.offset.x = -(self.parent.sprite.origin.x * self.parent.animation.width) + hb.x
			self.parent.physics.offset.y = -(self.parent.sprite.origin.y * self.parent.animation.height) + hb.y

			if self.parent.x < 0
			or self.parent.x > game.roomWidth
			or self.parent.y < 0
			or self.parent.y > game.roomHeight then
				print "removing for out of bounds"
				game:remove(self.parent)
			end

			if self.shouldExplode then
				game:remove(self.parent)
				explode(self.parent.center.x, self.parent.center.y, 16)
			end
		end,
		isEnemy = function(self)
			return true
		end,
		collide = function(self, collision, isOther)
			local other = isOther and collision.item or collision.other

			if other.type == "map" or (other.physics and (other.physics.collides and not other.behavior:isEnemy())) then
				if other.class == "player" then
					if not other.behavior.invulnerable then
						other.behavior.state:kill(other)
					end
				else
					self.shouldExplode = true
				end
			end

			if other.class == "ball" then
				self.shouldExplode = true
			end
		end,
	}
end
