--
--
--
--
--

return function()
	return {
		waitToClose = 0,
		timer = 0.5,
		lastShot = 0,
		shotTimer = 0.5,
		awake = function(self)
			self.parent.y = self.parent.y - self.parent.physics.offset.y - 16

			self.state = game:machine{
				initial = "closed",
				events = {
					{name = "open", from = "closed", to = "open"},
					{name = "close", from = "open", to = "closed"},
					{name = "kill", from = {"closed", "open"}, to = "dead"}
				},
				callbacks = {
					onstatechange = function(self, event, to, from, parent)

					end,
					onclose = function(self, event, to, from, parent)
						local lc = game.context
						game.context = parent

						play_animation "closing"
						set_animation "closed"

						game.context = lc
					end,
					onopen = function(self, event, to, from, parent)
						local lc = game.context
						game.context = parent

						play_animation "opening"
						set_animation "open"

						game.context = lc
					end
				}
			}

			if self.parent.dir == "left" then
				self.parent.sprite.flip.x = true
			end
		end,
		update = function(self, dt, speed)
			local hitbox = self.parent.sprite.slices.hitbox.frames[self.parent.animation.index]
			local flip = self.parent.sprite.flip.x

			self.parent.physics.width = hitbox.bounds.w
			self.parent.physics.offset.x = flip and self.parent.animation.width - hitbox.bounds.w - hitbox.bounds.x or hitbox.bounds.x
			self.parent.physics.offset.y = hitbox.bounds.y
			self.parent.physics.height = hitbox.bounds.h

			if self[self.state.current] then
				self[self.state.current](self, dt, speed)
			end
		end,
		open = function(self, dt, speed)
			local box = {
				x = self.parent.x + self.parent.physics.offset.x,
				y = self.parent.y + self.parent.physics.offset.y,
				h = self.parent.physics.height,
			}

						local player = game:get "player"

			if self.parent.dir == "left" then
				if player.sprite.flip.x then
					self.waitToClose = 0
				else
					self.waitToClose = self.waitToClose + (dt * speed)

					if self.waitToClose > self.timer then
						self.state:close(self.parent)
					end
				end
			else
				if player.sprite.flip.x then
					self.waitToClose = self.waitToClose + (dt * speed)

					if self.waitToClose > self.timer then
						self.state:close(self.parent)
					end
				else
					self.waitToClose = 0
				end
			end

			self.lastShot = self.lastShot + (dt * speed)

			if self.lastShot > self.shotTimer then
				local dir = game.definitions.directions[self.parent.dir]

				game:add("enemies/bone", {
					x = (self.parent.x + self.parent.physics.offset.x) - ((self.parent.x + self.parent.physics.offset.x) % 8),
					y = (self.parent.y + self.parent.physics.offset.y) - ((self.parent.y + self.parent.physics.offset.y) % 8) - 6,
					physics = {
						velocity = {
							x = dir.x * 200,
							y = dir.y * 200
						},
						gravity = {
							x = 0,
							y = 0
						}
					}
				})
				self.lastShot = 0
			end
		end,
		isEnemy = function(self)
			return true
		end,
		doesExplode = function(self)
			return false
		end,
		closed = function(self, dt, speed)
					local player = game:get "player"
			if self.parent.dir == "left" then
				if player.sprite.flip.x then
					self.state:open(self.parent)
				end
			else
				if not player.sprite.flip.x then
					self.state:open(self.parent)
				end
			end
		end,
	}
end
