--
--
--
--
--

return function()
	return {
		touchedPlayer = false,
		touchingPlayer = false,
		age = 0,
		bind = true,
		window = 0.3,
		awake = function(self)
			self.parent.y = self.parent.y - 8
		end,
		update = function(self, dt, speed)
			if self.bind then
				if self.parent.x < -self.parent.animation.width
				or self.parent.x > game.roomWidth + self.parent.physics.width
				or self.parent.y > game.roomHeight + self.parent.physics.height then
					if self.parent.spawner then
						self.parent.spawner.lastSpawn = 0
					end
					game:remove(self.parent)
				end
			end

			if self.touchedPlayer then
				if not self.touchingPlayer then
					wait(0.3)
					code(function(self)
						self.parent.physics.gravity.y = false
					end)
				else
					self.parent.sprite.offset.x = (math.random(2) - 1) * math.lerp(1, 3, self.age / self.window)
					self.parent.sprite.offset.y = (math.random(2) - 1) * math.lerp(1, 3, self.age / self.window)

					self.age = self.age + (dt * speed)

					if self.age > self.window then
						self.parent.physics.gravity.y = false
					end
				end
			end

			self.touchingPlayer = false
		end,
		doesExplode = function(self)
			return false
		end,
		collide = function(self, collision, isOther)
			other = collision.other

			if isOther then
				other = collision.item
			end

			if other.type == "map" then
				explode(self.parent.x, self.parent.y, 8)
				if self.parent.spawner then
					self.parent.spawner.lastSpawn = 0
				end
				game:remove(self.parent)
			end

			if other.class == "player" then
				self.touchingPlayer = true
				self.touchedPlayer = true
				self.parent.animation:setAnimation "touching"
			end
		end
	}
end
