--
--
--
--
--

return function()
	return {
		attached = false,
		update = function(self, dt, speed)
			local hitbox = self.parent.sprite.slices.hitbox.frames[self.parent.animation.index]
			local flip = self.parent.sprite.flip.x
			local lastphys = {
				x = self.parent.physics.offset.x,
				y = self.parent.physics.offset.y,
				w = self.parent.physics.width,
				h = self.parent.physics.height
			}

			self.parent.physics.width = hitbox.bounds.w
			self.parent.physics.offset.x = flip and self.parent.animation.width - hitbox.bounds.w - hitbox.bounds.x or hitbox.bounds.x
			self.parent.physics.offset.y = hitbox.bounds.y
			self.parent.physics.height = hitbox.bounds.h

			if self.attached then
				local attached = game:get(self.attached)

				if attached then
					self.parent.x = attached.x
					self.parent.y = attached.y
				end
			end
		end,
		collide = function(self, collision)
			if collision.other.class == "player" then
				game:remove(self.parent)
				state("has_key", true)
				game.audio:play("assets/sounds/key.wav", "sfx")
			end
		end
	}
end
