

return function()
	return {
		dir = -1,
		vision = 500,
		pattern = 2,
		walkSpeed = 64,
		awake = function(self)
			self.parent.x = self.parent.x - self.parent.physics.offset.x
			self.parent.y = self.parent.y - self.parent.physics.height
			self.state = game:machine{
				initial = "idle",
				events = {
					{name = "idle", from = {"hurt", "walk", "stun", "attacking"}, to = "idle"},
					{name = "walk", from = {"idle", "stun", "attacking"}, to = "walk"},
					{name = "stun", from = {"idle", "attacking"}, to = "stun"},
					{name = "hurt", from = {"idle", "walk", "attacking", "stun"}, to = "hurt"},
					{name = "attack", from = {"idle", "walk"}, to = "attacking"},
					{name = "kill", from = {"idle", "walk", "attacking", "hurt", "stun"}, to = "dead"}
				},
				callbacks = {
					onstatechange = function(self, event, to, from, parent)

					end,
					onattack = function(self, event, to, from, parent)
						print "Attacking"
						local lc = game.context
						game.context = parent
						velocity {x = 0, y = 0}

						play_animation "telegraph"

						if parent.behavior.pattern == 1 then
							play_animation "telegraph"
							code(function(self, options)
								game:add("enemies/bone", {
									x = self.parent.x,
									y = self.parent.y,
									dir = self.parent.behavior.dir,
									physics = {
										velocity = {
											y = -250,
											x = math.dist(self.parent.x, self.parent.y, game:get("player").x, game:get("player").y) * (self.parent.x > game:get("player").x and -1 or 1)
										}
									}
								})
							end)
							play_animation "followthru"
						elseif parent.behavior.pattern == 2 then
							for i = 1, 5 do
								play_animation "telegraph"
								wait(i / 10)
								code(function(self, options)
									game:add("enemies/bone", {
										x = self.parent.x,
										y = self.parent.y,
										dir = self.parent.behavior.dir,
										physics = {
											velocity = {
												y = 0 - (self.options.i * 100),
												x = ((0.5 + ((i / 5) / 2)) * 400) * self.parent.behavior.dir
											}
										}
									})
								end, {i = i})
								play_animation "followthru"
							end
						end

						code(function (self)
							self.parent.behavior.state:idle(self.parent)
						end)
						game.context = lc
					end,
					onhurt = function(self, event, to, from, parent)
						local lc = game.context
						game.context = parent

						play_animation "hurt"
						set_animation "idle"
						code(function(self)
							self.parent.behavior.state:idle(self.parent)
						end)

						game.context = lc
					end,
					onkill = function(self, event, to, from, parent)
						local lc = game.context
						game.context = parent
						parent.queue:clear()
						velocity {x = 0, y = 0}
						play_animation "hurt"
						fx("explode", parent.x + 12, parent.y + 24, true)
						removeSelf()
						game.context = lc
					end
				}
			}

			self.parent.physics._collide = self.parent.physics.collide
			self.parent.physics.collide = function(self, other)
				if other.class == "ball" then
					return "slide"
				elseif other.class == "player" then
					if other.behavior.invulnerable then
						return "cross"
					else
						return "slide"
					end
				else
					return self.physics._collide(self, other)
				end
			end
		end,
		update = function(self, dt, speed)
			local hitbox = self.parent.sprite.slices.hitbox.frames[self.parent.animation.index]
			local flip = self.parent.sprite.flip.x

			self.parent.physics.width = hitbox.bounds.w
			self.parent.physics.offset.x = flip and self.parent.animation.width - hitbox.bounds.w - hitbox.bounds.x or hitbox.bounds.x
			self.parent.physics.offset.y = hitbox.bounds.y
			self.parent.physics.height = hitbox.bounds.h

			if self[self.state.current] then
				self[self.state.current](self, dt, speed)
			end
		end,
		isEnemy = function(self)
			return true
		end,
		collide = function(self, collision)
			if collision.other.class == "ball" then
				local hitEnemies = collision.other.behavior.hitEnemies
				local doHit = true
				for index, enemy in pairs(hitEnemies) do
					if enemy == self.parent then
						doHit = false
					end
				end

				if doHit then
					collision.other.behavior.shouldExplode = true
					self:takeHit()
					table.insert(collision.other.behavior.hitEnemies, self.parent)
					print "HURT"
				else

				end
			end
		end,
		idle = function(self, dt, speed)
			if self.pattern == 1 then
				self.state:walk(self.parent)
			else
				self.state:attack(self.parent)
			end
		end,
		walk = function(self, dt, speed)
			local flip = false

			if self.parent.physics.touch.left or self.parent.physics.touch.right then
				flip = true
			end

			local items, len = phys():queryPoint(
				self.parent.x + (self.parent.physics.offset.x) + (self.parent.physics.width / 2) + (self.parent.physics.velocity.x * (dt * speed)),
				self.parent.y + self.parent.physics.height + self.parent.physics.offset.y + 2
			)

			if len == 0 then
				flip = true
			end

			if flip then
				self.parent.sprite.flip.x = not self.parent.sprite.flip.x
				self.dir = -self.dir
			end

			self.parent.animation:setAnimation "walk"
			self.parent.physics.velocity.x = self.walkSpeed * self.dir

			local items, len = phys():querySegment(
				self.parent.x + (self.parent.physics.offset.x) + (self.parent.physics.width / 2),
				self.parent.y + (self.parent.physics.height / 2) + self.parent.physics.offset.y,
				self.parent.x + (self.parent.physics.offset.x) + (self.parent.physics.width / 2) + (self.dir * self.vision),
				self.parent.y + (self.parent.physics.height / 2) + self.parent.physics.offset.y
			)

			local attack = false

			if len > 0 then
				for index, item in pairs(items) do
					if item.class == "player" then
						attack = true
					end
				end
			end

			if attack then
				self.state:attack(self.parent)
			end
		end,
		takeHit = function(self)
			self.state:kill(self.parent)
		end,
		onBellRing = function(self)
			self.state:hurt(self.parent)
		end,
		on_hit = function(self, interactor)
			print "STUN"
		end
	}
end
