--
--
--
--
--

return function()
	return {
		touch = true,
		active = false,
		tweenDoor = false,
		doneTween = false,
		validState = function(self)
			return true
		end,
		update = function(self, dt, speed)
			self.active = not self.touch
			self.touch = false

			if not self.active and self.parent.name == "entrance" and not self.doneTween then

				local lc = game.context
				local player = game:get "player"
				game.context = player
				local target = game:get("entrance_door")
				game.locked = true
				set_animation "walk"

				if target then
					print "doing tween"

					if target.x > player.x then
						player.sprite.flip.x = true
					else
						player.sprite.flip.x = false
					end

					tween_to {x = target.x + 32, y = target.y , t = 3}
				end

				unlock()
				game.context = self.parent
				removeSelf()
				game.context = lc
				self.doneTween = true
			end
		end,
		awake = function(self)
			self.active = false
			self.parent.physics.width = self.parent.width
			self.parent.physics.height = self.parent.height

			if self.parent.class == "entrance" or self.parent.class == "exit" then
				self.parent.y = self.parent.y - 8

				if self.parent.next_room then
					self.parent.target = self.parent.next_room .. "#entrance"
				else
					self.parent.target = game.lastRoom .. "#entrance"
				end

				if self.expand then
					if self.parent.expand.left then
						print "expanding left"
						local ax, ay, cols, len = phys():check(self.parent, 0, self.parent.y)
						self.parent.x = ax
						self.parent.physics.height = ax - self.parent.x
						phys():update(self.parent, self.parent.x, self.parent.y)
					end

					if self.parent.expand.right then
						print "expanding right"
						local ax, ay, cols, len = phys():check(self.parent, game.roomWidth, self.parent.y)
						self.parent.physics.width = (ax + self.parent.physics.width)
						phys():update(self.parent, self.parent.x, self.parent.y)
					end

					if self.parent.expand.up then
						print "expanding up"
						local ax, ay, cols, len = phys():check(self.parent, self.parent.x, 0)
						self.parent.y = ay
						self.parent.physics.height = ay - self.parent.y
						phys():update(self.parent, self.parent.x, self.parent.y)
					end

					if self.parent.expand.down then
						print "expanding down"
						local ax, ay, cols, len = phys():check(self.parent, self.parent.x, game.roomHeight)
						self.parent.physics.height = math.max(8, ay + self.parent.physics.height)
						phys():update(self.parent, self.parent.x, self.parent.y)
					end

					phys():update(self.parent, self.parent.x, self.parent.y)
				end
			end
        end,
		collide = function(self, collision)
			if collision.other.name == "player" then
				self.touch = true



				if self.active and areQueuesEmpty{} then
					game.lastUsedWarp = self.parent.target
					warp(self.parent.target)
				end
			end
		end,
		draw = function(self)
			if game.debugMode then
				local lc = love.graphics.getCanvas()
				love.graphics.setCanvas(game.layers.debug)

				if self.active then
					love.graphics.setColor(0, 255, 0)
				else
					love.graphics.setColor(255, 0, 0)
				end

				love.graphics.rectangle("line", self.parent.x + game.camera.x, self.parent.y + game.camera.y, self.parent.width, self.parent.height)
				love.graphics.setColor(255, 255, 255)
				love.graphics.setCanvas(lc)
			end
		end
	}
end
