local tiled = "C:\\Users\\EulerHopepunk\\AppData\\Roaming\\itch\\apps\\tiled\\tiled.exe"
local dir = "C:\\Users\\EulerHopepunk\\Documents\\Projects\\dead rubber\\assets\\rooms"

require "lfs"

function dirtree(dir)
  assert(dir and dir ~= "", "directory parameter is missing or empty")
  if string.sub(dir, -1) == "/" then
    dir=string.sub(dir, 1, -2)
  end

  local diriters = {lfs.dir(dir)}
  local dirs = {dir}

  return function()
    repeat 
      local entry = diriters[#diriters]()
      if entry then 
        if entry ~= "." and entry ~= ".." then 
          local filename = table.concat(dirs, "\\").."\\"..entry
          local attr = lfs.attributes(filename)
          if attr.mode == "directory" then 
            table.insert(dirs, entry)
            table.insert(diriters, lfs.dir(filename))
          end
          return filename, attr
        end
      else
        table.remove(dirs)
        table.remove(diriters)
      end
    until #diriters==0
  end
end

for i in dirtree(dir) do
	if lfs.attributes(i, "mode") == "file" then 
		print(string.format("Exporting map: %s", i:sub(#dir + 1)))
		os.execute(string.format('%s --export-map json --resolve-types-and-properties "%s" "%s"', tiled, i, i))
	end
end
