--
--
--
--
--

return function()
    return {
        particles = {},
        direction = {
            x = 0,
            y = 10,
        },
        age = 0,
        delay = 1,
        particle = "assets/sprites/smoke.png",
        particleAge = 2,
        script = false,
		randomize = false,
		anchored = false,
        update = function(self, dt, speed)
            if not self.particleTexture then
                self.particleTexture = love.graphics.newImage(self.particle)
            end

            self.age = self.age + (dt * speed)
            if self.age > self.delay then
                table.insert(self.particles, {
                    x = self.x + math.random(0, self.width),
                    y = self.y + math.random(0, self.height),
                    age = 0,
					velocity = {
						x = self.randomize and math.random(0, self.direction.x) or self.direction.x,
						y = self.randomize and math.random(0, self.direction.y) or self.direction.y
					}
                })
                self.age = 0

                if self.script then
                    loadstring(self.script)()
                end
            end

            for index, particle in ipairs(self.particles) do
                particle.age = particle.age + (dt * speed)

                particle.x = particle.x + (particle.velocity.x * (dt * speed))
                particle.y = particle.y + (particle.velocity.y * (dt * speed))

                if particle.age > self.particleAge then
                    table.remove(self.particles, index)
                end
            end
        end,
        draw = function(self)
            local lc = love.graphics.getCanvas()
            love.graphics.setCanvas(game.layers.particles)

            for index, particle in pairs(self.particles) do
				if self.anchored then
                	love.graphics.draw(self.particleTexture, math.floor(particle.x), math.floor(particle.y))
				else
					love.graphics.draw(self.particleTexture, math.floor(game.camera.x + particle.x), math.floor(game.camera.y + particle.y))
				end
            end

            love.graphics.setCanvas(lc)
        end
    }
end
