--
--
--
--
--
return function()
    return {
        x = 8,
        y = 8,
        z = 0,

        width = game.width - 8,
        height = false,

        age = 0,
        speed = 30,

        class = "choice",
        portrait = false,
        buttons = {},
        selected = 1,


        update = function(self, dt, speed)
            self.age = self.age + (dt * speed)
            local spacer = " "

            if type(self.portrait) == "string" or self.portrait == true then
                self.portrait = game:add(
                    {
                        x = self.x + 8, y = self.y + 8, z = -15,
                        class = "portrait",
                        animation = {
                            schema = "assets/animations/portraits.json",
                        },

                        sprite = {
                            anchored = true,
                            sprite = "assets/sprites/portraits.png",
                            origin = {
                                x = 0, y = 0
                            },
                            visible = true,
                            layer = "ui_fg"
                        }
                    },
                    {
                        animation = {
                            current = (self.portrait == true and game.speaker or self.portrait)
                        }
                    }
                )
            end

            if not self.height and self.text then
                local width, wrapped = game.fonts[game.defaultFont]:getWrap(self.text, self.width - 8 - (self.portrait and 52 or 0))
                self.height = 16 * (#wrapped)
            elseif not self.height and not self.text then
                self.height = 128
            end

            if self.text ~= nil then
                self.drawText = self.text:sub(1, math.min(#self.text, self.age * self.speed))
                self.drawText = self.drawText .. spacer:rep(#self.text - #self.drawText)
            end


            self.selected = math.clamp(self.selected, 1, #self.buttons)

            if game.controls:pressed "a" then
                if self.text then
                    if #self.drawText >= #self.text then
                        if type(self.buttons[self.selected].onclick) == "string" then
                            loadstring(self.buttons[self.selected].onclick)(self)
                        else
                            self.buttons[self.selected].onclick(self)
                        end
                    end
                else
                    if type(self.buttons[self.selected].onclick) == "string" then
                        loadstring(self.buttons[self.selected].onclick)(self)
                    else
                        self.buttons[self.selected].onclick(self)
                    end
                end

                game:remove(self)
                if self.portrait then
                    game:remove(self.portrait)
                end
            end
        end,
        draw = function(self)
            local lc = love.graphics.getCanvas()
            love.graphics.setCanvas(game.layers.ui)

            if self.text then
                game.windows.dialogue:draw(self.x, self.y, self.width - 8, self.height)
                love.graphics.setColor(255, 255, 255)
                love.graphics.printf(self.drawText, self.x + (self.portrait and 52 or 16), self.y + 10, self.width - 8 - (self.portrait and 52 or 0), "left")

                if self.age % 1 < 0.5 then
                    love.graphics.polygon("fill",
                        self.x + self.width - 24 - 8, self.y + self.height - 8,
                        self.x + self.width - 16 - 8, self.y + self.height - 8,
                        self.x + self.width - 20 - 8, self.y + self.height - 8
                    )
                end
            end

            game.windows.dialogue:draw(self.x, self.y + self.height + 8, self.width - 8, 32 + (16 * (#self.buttons - 1)))

            for index, button in ipairs(self.buttons) do
                if index == self.selected then
                    love.graphics.printf("> " .. button.label, self.x + 8, self.y + self.height + (16 * index) + 8, self.width - 16, "left")
                else
                    love.graphics.printf(button.label, self.x + 8, self.y + self.height + (16 * index) + 8, self.width - 16, "left")
                end
            end

            love.graphics.setCanvas(lc)
        end
    }
end
