--
--
--
--

return function()
    return {
        x = 8,
        y = 8,
        z = 0,

        class = "window",
        layer = "ui",
        font = game.defaultFont,
        choiceFont = game.defaultFont,
		type = "dialogue",

		npc = false,
		currentNPC = false,

		changeSide = false,
		scrollWithWindow = true,

        width = game.width - 16,
        height = 48,
        sized = false,
        doSize = true,
		visible = true,

		useLinks = false,
		links = {
			up = false,
			down = false,
			left = false,
			right = false
		},

        drawBackground = true,
        canClose = true,

        hasPortrait = false,
		portrait = false,
        portraitID = false,
        portraitSprite = false,
        portraitHeight = 48,
        portraitWidth = 48,
        portraitPadding = 8,
		emotion = false,

		anchored = true,

        choices = false,
		removeOnConfirm = true,
        selectedChoice = 1,
		choiceLayer = "ui_bg",
		choiceX = 0,
		choiceY = 0,
		minChoiceWidth = 1,
		maxChoiceWidth = 1,

        age = 0,
        text = false,
        queuedText = false,
        textIndex = 1,
        scanPos = 1,
        currentPos = 1,
        maxLength = 0,
        typeText = true,
        candidateText = false,
        stillRendering = true,
        lastTextLength = 0,
        textAreaSize = 200,
        textPadding = 12,
        linePadding = 4,
        lastTextFloor = 0,
        textLength = 0,
        sound = false,
        drawSpeed = 30,
        drawSpeedMult = 10,

		takesInput = true,
		active = true,

		queuedText = {},

		setNPC = function(self, npc)
			if npc == false then
				self.font = game.defaultFont
				self.portrait = false
				self.hasPortrait = false
				self.sound = "assets/sounds/type.wav"
			else
				self.currentNPC = npc
				self.font = game.npcs[npc].font
				self.portrait = game.npcs[npc].portrait
				self.sound = game.npcs[npc].voice
			end
		end,

        update = function(self, dt, speed)
			if self.emotion == "false" then
				self.emotion = false
			end

			if self.npc ~= self.currentNPC then
				self:setNPC(self.npc)
			end

            if self.portrait then
                self.hasPortrait = true
            end

			if #self.queuedText > 0 and not self.text then
				self.text = self.queuedText[1]
				table.remove(self.queuedText, 1)
			end

			if self.active then
            	game.locked = true
	          	self.age = self.age + (dt * speed)
			end

            if self.doSize and not self.sized then
				local th = game.fonts[self.choiceFont]:getHeight()
                self.textAreaSize = self.width - (self.textPadding * 2)
				self.choiceHeight = ((th + self.linePadding) * (self.choices and #self.choices + 3 or 1)) + self.textPadding


                if self.text then
					local formatted = 0
					if type(self.text) == "table" then
						for index, text in pairs(self.text) do
							if type(text) == "string" then
								formatted = formatted .. text
							end
						end
					else
						formatted = self.text
					end

                    local width, lines = game.fonts[self.font]:getWrap(formatted, self.textAreaSize)
                    self.height = (#lines * game.fonts[self.font]:getHeight()) + (self.textPadding * 2)
					self.height = math.max(self.height, 64)
                end

				if game.camera.following and self.changeSide then
					local following = game:get(game.camera.following)

					if following then

						local x, y = game.camera:getScreenPosition(following.x, following.y)

						if y < game.height / 2 and y >= 0 then
							self.y = game.height - self.height - 8
						end

						self.choiceY = -self.choiceHeight - 48
					end
				end


				if self.npc then
					self.font = game.npcs[self.npc].font
					self.portrait = game.npcs[self.npc].portrait
					self.sound = game.npcs[self.npc].voice
				end

                if self.portrait then
                    self.hasPortrait = true
                end

                if self.hasPortrait then
                    self.textAreaSize = self.width - self.portraitWidth - (self.portraitPadding * 4) - (self.textPadding * 2)

                    self.portraitSprite = game:add{
                        x = self.x + self.portraitPadding,
                        y = self.y + self.portraitPadding,
                        class = "portrait",
                        animation = {
                            schema = "assets/sprites/portraits.json"
                        },

                        sprite = {
                            anchored = true,
                            sprite = "assets/sprites/portraits.png",
                            origin = {
                                x = 0, y = 0
                            },
                            visible = true,
                            layer = "ui_fg"
                        }
                    }

                    self.portraitSprite.animation:setAnimation(self.portrait, true)
                end


                self.sized = true
            end

			if self.portrait and self.hasPortrait then
				if self.emotion then
					self.portraitSprite.animation:setAnimation(f("%s_%s", self.portrait, self.emotion))
				else
					self.portraitSprite.animation:setAnimation(self.portrait)
				end
			end

            if self.text and self.typeText then
                self.lastTextLength = self.textLength
                self.textLength = self.textLength + (dt * speed * (self.drawSpeed * self.drawSpeedMult))

                if type(self.text) == "table" then
                    local stillRendering = true

                    self.candidateText = {}
                    self.scanPos = self.textLength

                    for i = 1, #self.text do
                        if type(self.text[i]) == "table" then
                            table.insert(self.candidateText, self.text[i])
                        elseif type(self.text[i]) == "string" then
                            if self.scanPos < #self.text[i] then
                                table.insert(self.candidateText, self.text[i]:sub(1, math.floor(self.scanPos)))
                            else
                                self.scanPos = self.scanPos - #self.text[i]
                                table.insert(self.candidateText, self.text[i])

                                if i >= #self.text then
                                    stillRendering = false
                                end
                            end
                        end
                    end

                    if not stillRendering then
                        self.stillRendering = false
                    end
                else
                    if self.textLength > #self.text then
                        self.textLength = #self.text
                        self.candidateText = self.text
                        self.stillRendering = false
                    else
                        self.candidateText = self.text:sub(1, math.floor(self.textLength))
                    end
                end

                if math.floor(self.lastTextLength) < math.floor(self.textLength) and self.stillRendering then
					if self.sound then
                    	game.audio:play(self.sound, "sfx")
					end
                end
            end

            if game.controls:down "b" then
                self.drawSpeedMult = 5
            else
                self.drawSpeedMult = 1
            end

			if self.useLinks then
				local dirs = {'up', 'down', 'left', 'right'}

				for index, dir in pairs(dirs) do
					if game.controls:pressed(dir) then
						if self.links[dir] and game:get(self.links[dir]) then
							self.takesInput = false
							game:get(self.links[dir]).takesInput = true
						end
					end
				end
			end

			if self.active then
	            if self.choices and self.takesInput and #self.queuedText == 0  then
	                if game.controls:pressed 'up' then
	                    self.selectedChoice = self.selectedChoice - 1
	                    if self.selectedChoice == 0 then
	                        self.selectedChoice = #self.choices
	                    end
	                end

	                if game.controls:pressed 'down' then
	                    self.selectedChoice = self.selectedChoice + 1
	                    if self.selectedChoice > #self.choices then
	                        self.selectedChoice = 1
	                    end
	                end
	            end

	            if game.controls:pressed "a" and self.takesInput then

	                if self.choices and #self.queuedText == 0 then
	                    if self.text then
	                        if #self.candidateText >= #self.text then
								if self.choices[self.selectedChoice].onclick then
		                            if type(self.choices[self.selectedChoice].onclick) == "string" then
		                                loadstring(self.choices[self.selectedChoice].onclick)(self)
		                            else
		                                self.choices[self.selectedChoice].onclick(self)
		                            end

									if self.removeOnConfirm then
			                            self:remove()
									end
								end
	                        end
	                    else
							if self.choices[self.selectedChoice].onclick then
		                        if type(self.choices[self.selectedChoice].onclick) == "string" then
		                            loadstring(self.choices[self.selectedChoice].onclick)(self)
		                        else
		                            self.choices[self.selectedChoice].onclick(self)
		                        end
							end

							if self.removeOnConfirm then
								self:remove()
							end
	                    end
	                else
						self:remove()
	                end
	            end
			end
        end,
		remove = function(self)
			if #self.queuedText > 0 then
				self.text = self.queuedText[1]
				table.remove(self.queuedText, 1)
				self:ready()
			else
				game:remove(self)
	            game.locked = false

	            if self.portraitSprite then
	                game:remove(self.portraitSprite)
	            end
			end
		end,
		ready = function(self)
			if self.text ~= nil then
				if self.text[1] == "@" then
					local t = ""

					for index, str in pairs(self.text) do
						if index ~= 1 then
							if type(str) == "string" then
								t = t .. str
							end
						end
					end

					for index, tag in pairs(t:separate(';')) do
						local bites = tag:separate ':'
						local tag = bites[1]
						local value = bites[2]

						printf("Setting %s to %s", tag, value)
						self[tag] = value
					end

					self.text = self.queuedText[1]
					table.remove(self.queuedText, 1)
					self:ready()
				elseif self.text[1] == "%" then
					local t = ""

					for index, str in pairs(self.text) do
						if index ~= 1 then
							if type(str) == "string" then
								t = t .. str
							end
						end
					end

					loadstring(t)()

					self.text = self.queuedText[1]
					table.remove(self.queuedText, 1)
					self:ready()
				end

				self.textIndex = 1
				self.scanPos = 1
				self.currentPos = 1
				self.textLength = 0
				self.lastTextLength = 0
				self.candidateText = ""
				self.maxLength = 0
				self.stillRendering = true
			end
		end,
        draw = function(self)
			if not self.visible then
				return false
			end

			local drawX = math.floor(self.anchored and 0 or game.camera.x) + self.x
			local drawY = math.floor(self.anchored and 0 or game.camera.y) + self.y

            local lc = game:setLayer(self.layer)
            love.graphics.setFont(game.fonts[self.font])
			local fo = game.fontSpecs[self.font].offset or 0

            if self.text then
                if self.drawBackground then
                    game.windows[self.type]:draw(drawX, drawY, self.width, self.height)
                end

                local textX = drawX + self.textPadding
                local textY = drawY + self.textPadding

                if self.hasPortrait then
                    textX = textX + self.portraitWidth + (self.portraitPadding)
                end

                love.graphics.printf(self.candidateText, textX, textY + fo, self.textAreaSize, "left")

                if self.age % 1 < 0.5 and self.drawBackground and self.takesInput then
                    love.graphics.polygon("fill",
                        drawX + self.width - 2, drawY + self.height - 8,
                        drawX + self.width - 10, drawY + self.height - 8,
                        drawX + self.width - 6, drawY + self.height - 4
                    )
                end
            end

            -- Draw choices
            if self.choices and #self.queuedText == 0 then
				local drawX = self.x + self.choiceX + math.floor(self.anchored and 0 or game.camera.x)
				local drawY = self.y + self.choiceY + math.floor(self.anchored and 0 or game.camera.y)

                local th = game.fonts[self.choiceFont]:getHeight()
				love.graphics.setFont(game.fonts[self.choiceFont])
				local lc = game:setLayer(self.choiceLayer)

				local yOffset = 0
				local lineHeight = drawY + self.height + ((th + self.linePadding) * self.selectedChoice) + 16

				if lineHeight > game.height then
					while lineHeight > game.height do
						lineHeight = lineHeight - (game.height / 4)
						yOffset = yOffset - (game.height / 4)
					end
				end

				if self.drawBackground then
                    game.windows[self.type]:draw(drawX, yOffset + drawY + self.height + 8, self.width, (#self.choices * (th + self.linePadding)) + (self.textPadding * 2))
                end


                for index, choice in pairs(self.choices) do
					if self.hasPortrait then
						local tw = self.textAreaSize + self.portraitWidth + (self.portraitPadding * 2)
	                    if index == self.selectedChoice and self.takesInput then
	                        love.graphics.printf(formatText(f("^Yellow>^White %s", choice.label)), drawX + self.textPadding, yOffset + drawY + self.height + ((th + self.linePadding) * index) + self.textPadding, tw, "left")
	                    else
	                        love.graphics.printf(formatText("  " .. choice.label), drawX + self.textPadding, yOffset + drawY + self.height + ((th + self.linePadding) * index) + self.textPadding, tw, "left")
	                    end
					else
	                    if index == self.selectedChoice and self.takesInput then
	                        love.graphics.printf(formatText(f("^Yellow>^White %s", choice.label)), drawX + self.textPadding, yOffset + drawY + self.height + ((th + self.linePadding) * index) + self.textPadding, self.textAreaSize, "left")
	                    else
	                        love.graphics.printf(formatText("  " .. choice.label), drawX + self.textPadding, yOffset + drawY + self.height + ((th + self.linePadding) * index) + self.textPadding, self.textAreaSize, "left")
	                    end
					end
                end
            end

			if game.debugMode then
				game:setLayer("debug")
				love.graphics.setColor(255, 255, 0)
				if self.hasPortrait then
					love.graphics.rectangle("line", self.x + self.textPadding + self.portraitWidth + (self.portraitPadding * 2), self.y, self.textAreaSize, 2)
				else
					love.graphics.rectangle("line", self.x + self.textPadding, self.y, self.textAreaSize, 2)
				end
				love.graphics.setColor(255, 255, 255)
			end

            love.graphics.setCanvas(lc)
        end
    }
end
