--
--
--
--
--

game:remove "sprite"
game:cleanup()

local entity = game:add(game:get("file_text").interface.state.text, { name = "sprite", x = 200, y = 50})
print(table.inspect(entity))

-- oh boy! loading.

--
-- Load behavior schema.
--
print "Loading behavior schema..."
if entity.behavior then
    if entity.behavior.scheme then
        for key, value in pairs(entity.behavior.scheme) do
            if game:get(key) then
                game:get(key).interface.state.text = value
            end
        end
    else
        print "No scheme to load."
    end

    print "Behavior schema loaded."
else
    print "No behaviors detected."
end

--
-- Load physics.
--
game:get("box_x").interface.state.text = tostring(entity.physics.offset.x)
game:get("box_y").interface.state.text = tostring(entity.physics.offset.y)
game:get("box_w").interface.state.text = tostring(entity.physics.width)
game:get("box_h").interface.state.text = tostring(entity.physics.height)
game:get("drag_x").interface.state.text = tostring(entity.physics.drag.x)
game:get("drag_y").interface.state.text = tostring(entity.physics.drag.y)
game:get("gravity_x").interface.state.text = tostring(entity.physics.gravity.x)
game:get("gravity_y").interface.state.text = tostring(entity.physics.gravity.y)
game:get("vel_x").interface.state.text = tostring(entity.physics.velocity.max.x)
game:get("vel_y").interface.state.text = tostring(entity.physics.velocity.max.y)
game:get("collides").interface.state.checked = entity.physics.collides

--
-- Load sprites.
--
local animationName = entity.animation.schema:sub(#"assets/sprites/" + 1, #entity.animation.schema - 5)
print(animationName)
game:get("animation_text").interface.state.text = animationName
local spriteName = entity.sprite.sprite:sub(#"assets/sprites/" + 1, #entity.sprite.sprite - 4)
print(spriteName)
game:get("sprite_text").interface.state.text = spriteName
game:get("origin_x").interface.state.value = entity.sprite.origin.x
game:get("origin_y").interface.state.value = entity.sprite.origin.y
game:get("offset_x").interface.state.text = tostring(entity.sprite.offset.x)
game:get("offset_y").interface.state.text = tostring(entity.sprite.offset.y)

for index, color in pairs({'r', 'g', 'b', 'a'}) do
    game:get(color).interface.state.value = entity.sprite.color[color]
end

print "Reloading entity."
