--
--
--
--

local sprite = compress(game:get "sprite")
sprite.class = game:get("class").interface.state.text

local structure = [[
-- Last saved at %s
return function()
    return %s
end
]]

if not (os and io) then
    notice "Either the OS or IO library is missing. Saving to appdata."
    love.filesystem.createDirectory "assets"
    love.filesystem.createDirectory "assets/objects"

    love.filesystem.write(string.format("assets/objects/%s.lua", game:get("file_text").interface.state.text), string.format(structure, table.inspect(sprite)))
    print ("Saved entity " .. sprite.class)
else
    print "Saving with OS/IO"
    local obj = io.open(string.format("%s/assets/objects/%s.lua", love.filesystem.getWorkingDirectory( ), game:get("file_text").interface.state.text), "w")
    io.output(obj)
    io.write(string.format(structure, os.date(), table.inspect(sprite)))
    io.close(obj)
end
