--
--
--
--
--

return function()
	return game.component({
		width = 16,
		height = 16,

		body = false,
		collides = false,
		lock = false,
		anchored = false,

		baseVelocity = {
			x = 0,
			y = 0
		},

		lastTouch = {
			top = false,
			left = false,
			right = false,
			bottom = false,
		},
		touch = {
			top = false,
			left = false,
			right = false,
			bottom = false
		},
		dirs = {
			top = true,
			left = true,
			right = true,
			bottom = true
		},

		filter = function(self, other)
			if other.collides and self.collides then
				return "touch"
			else
				return "cross"
			end
		end,
		collide = function(self, other)
			return (self.physics.collides and ((other.physics and other.physics.collides) or (other.type == "map" or (other.properties and other.properties.collides)))) and "slide" or "cross"
		end,
		script = "collides/default",
		sound = "assets/sounds/staple_gun.mp3",

		type = "sprite",
		useTiledWidth = false,

		offset = {
			x = 0,
			y = 0
		},

		bounces = false,
		bounce = {
			x = 0,
			y = 0
		},

		velocity = {
			max = {
				x = 1024,
				y = 1024
			},
			x = 0,
			y = 0,
		},

		gravity = {
			x = false,
			y = false,
		},

		drag = {
			x = 0,
			y = 0,
		}
	})
end
