--
--
--
--
--

return function()
    local stats = game.component{
        name = "ENTITY",

		physics = {
			width = 1,
			height = 1,
			origin = {
				x = 0,
				y = 0
			}
		},

		sprite = {
			sprite = "entity",
			origin = {
				x = 0,
				y = 0.5,
			},
			flip = false,
		},
		behavior = "default",
        flavor = {
            pill = "Pill's description of this enemy.",
            moxey = "Moxey's description of this enemy.",
            book = "Book description of this enemy."
        },
		verb = "move",
        expDrop = 10,
        itemDrops = {

        },

        equips = {
            armor = false,
            weapon = false,
            accessory = false,
            ring = false,
        },

        level = 1,

		experience = {
            total = 0,
            scale = 1.1,
            base = 50,
        },

        learnset = {
            [1] = "wallop",
        },

        health = 5,
        maxHealth = 5,
		minHealth = 0,

        effect = false,

        actions = 5,
        maxActions = 5,

        attack = 3,
        dexterity = 0,
        magic = 0,
        speed = 1,
        armor = 3,
        weapon = 4,

        controllable = false,

        isEnemy = true,

        baseStats = {
            attack = 3,
            dexterity = 0,
            magic = 0,
            speed = 1,
            armor = 1,
            weapon = 4,
        },

        boosts = {
            attack = 0,
            dexterity = 0,
            magic = 0,
            speed = 0,
            armor = 0,
            weapon = 0,
        },

        moved = false,

        weaknesses = {

        },
        resistances = {

        },

        intelligence = 0,
        targetMode = "random",
	}

    stats.controlOrder = {"FIGHT", "SKILL", "BAG", "RUN"}
    stats.controls = {
        {
            label = "FIGHT",
            onselect = function(self)
                game:get("battle_status").text = "Fight!"
            end,
            onclick = function(self)
                local p = skill("punch", self.parent)
				p:startup(self.parent)
            end
        },
        {
            label = stats.verb:capitalize(),
            onselect = function(self)
                game:get("battle_status").text = "???"
            end,
            onclick = function(self)
                game:get("verb_choice").active = false
                self.parent.stats.moved = true
            end
        },
        {
            label = "ITEMS",
            onselect = function(self)
                game:get("battle_status").text = "Use an item from your inventory."
            end,
            onclick = function(self)
                game:get("verb_choice").active = false
            	local i = skill("use_item", self.parent)
				i:startup(self.parent)
                self.parent.stats.moved = true
            end
        },
        {
            label = "MOVE",
            onselect = function(self)
                game:get("battle_status").text = "Move to another position."
            end,
            onclick = function(self)
				local m = skill('move', self.parent)
				m:startup(self.parent)
            end
        },
    }
    stats.skills = {}

	return stats
end
