--
--
--
--
--

return function()
	local cutscene = {
		initialTarget = false,
		initialContext = false,
		active = false,
		recording = false,
		involved = {},

		context = false,
	}

	function cutscene:start()
		self.recording = true

		game.promise:promise("cutscene", {
			onUpdate = function(self, dt, speed)
				local stillWaiting = false

				for index, waiting in pairs(game.cutscene:getInvolved()) do
					if waiting.queue:getActiveID() ~= "hold" then
						stillWaiting = true
					end
				end

				if stillWaiting then
					game.cutscene.active = true
				else
					game.promise:resolve "cutscene"
				end
			end,
			onResolve = function(self)
				game.cutscene:finish()
			end
		})
	end

	function cutscene:play()
		self:setTarget("entity")

		for index, involved in pairs(self:getInvolved()) do
			self:setContext(involved)
			hold()
		end
	end

	function cutscene:getInvolved()
		return self.involved
	end

	function cutscene:setContext(entity)
		if type(entity) == "string" then
			entity = game:get(entity)
		end

		local alreadyIn = false

		for index, involved in pairs(self:getInvolved()) do
			if involved == entity then
				alreadyIn = true
			end
		end

		if not alreadyIn then
			game.context = entity
			table.insert(self.involved, entity)
		end

	end

	function cutscene:setTarget(type)
		game.targetContext = type
	end

	function cutscene:finish()
		print "Finishing cutscene"

		for index, involved in pairs(self:getInvolved()) do
			if involved.queue:getActiveID() == "hold" then
				involved.queue.queue[1].finished = true
			end
		end

		game.cutscene.active = false
		game.targetContext = self.initialTarget
		game.context = self.initialContext
	end

	return cutscene
end
