--
--
-- Oh boy! A definitions file.
--
--
local definitions = {}

definitions.directions = {
    up = {x = 0, y = -1},
    down = {x = 0, y = 1},
    left = {x = -1, y = 0},
    right = {x = 1, y = 0}
}

definitions.comboSpeed = {500}
definitions.comboScore = {0, 	0, 	0,	0,		15,	15,	15, 15,			30,	30,	30,	30, 		40,	40,	40, 40, 100, 100, 100, 100}

definitions.damageTypes = {

}

definitions.elementalTypes = {
    magic = {
        weaknesses = {"sorcerie", "wizardry"}
    }
}

definitions.tabNames = {
	junk = "Junk",
	healing = "Medicine",
	candy = "Candy",
	key_items = "Key items"
}

definitions.tabDescriptions = {
	junk = "Trash. It's garbage. It's worthless.",
	candy = "Candies... sweet and good and delicious.",
	key_items = "Very important."
}

definitions.targetMode = {
    weakest = "weakest",
    strongest = "strongest",
    most_hurt = "most_hurt",
    least_hurt = "least_hurt",
    nearest = "nearest",
    furthest = "furthest",
    random = "random",
}

sort = {
	reference = {
		x = 0,
		y = 0
	},
    weakest = function(a, b)
        return a.stats.attack > b.stats.attack
    end,
    strongest = function(a, b)
        return a.stats.attack < b.stats.attack
    end,
    most_hurt = function(a, b)
        return (a.stats.maxHealth - a.stats.health) > (b.stats.maxHealth - b.stats.health)
    end,
    least_hurt = function(a, b)
        return (a.stats.maxHealth - a.stats.health) > (b.stats.maxHealth - b.stats.health)
    end,
    nearest = function(a, b)
        return math.dist(sort.reference.x, sort.reference.y, a.x, a.y) > math.dist(sort.reference.x, sort.reference.y, b.x, b.y)
    end,
    furthest = function(a, b)
        return math.dist(sort.reference.x, sort.reference.y, a.x, a.y) < math.dist(sort.reference.x, sort.reference.y, b.x, b.y)
    end,
    random = function(a, b)
        return (math.random(1, 2) == 1)
    end
}

return definitions
