--
--
--
--
--

return function(self, options)
    local queue = {
        queue = {},
        insert = false,
        type = "game",
        respectLocks = true,
		getActiveID = function(self)
			if not self.queue[1] then
				return false
			else
				return self.queue[1].id
			end
		end,
		isEmpty = function(self)
			return #self.queue == 0
		end,
        update = function(self, dt, speed)
        	local doingLoops = true

        	while doingLoops do
        		if self.queue[1] then
        			local event = self.queue[1]

                    if event.context ~= self.type and event.context ~= "any" then
                        printf("!! Warning: event (id:%s) context %s sent to queue type %s.", event.id, event.context, self.type)
                        table.remove(self.queue, 1)
                    else
            			if event.type == "instant" then
            				event:run()
            				table.remove(self.queue, 1)
            			else
            				if not event.started then
								if event.start then
            						event:start(dt, speed)
								end

            					event.started = true
            				end

            				if event.started then
            					event:update(dt, speed)
            				end

            				if event.finished then
            					if event.finish then
            						event:finish()
            					end

            					table.remove(self.queue, 1)
            				else
            					doingLoops = false
            				end
            			end
                    end
        		else
        			doingLoops = false
        		end
        	end
        end,
        add = function(self, object)
            if self.type == "entity" then
                object.parent = self.parent
            end

            if self.insert then
				table.insert(self.queue, self.insert, object)

				if self.keepLock then
					self.insert = self.insert + 1
				end

				game.queued = game.queued + 1
            else
                table.insert(self.queue, object)
                game.queued = game.queued + 1
            end
        end,
        clear = function(self)
            self.queue = {}
        end
    }

    if options ~= nil then
        queue = table.merge(queue, options)
    end

    local qmt = {
        __call = function(self, options)
            print "table call"
            self:add(game.event(options))
        end,
        __len = function(self)
            printf("Queue length: %i", #self.queue)
            return #self.queue
        end
    }
    setmetatable(queue, qmt)

    table.insert(self.queues, queue)
    return queue
end
