--
--
--
--
--

return function()
    local queue = game.system()

    function queue:filter(entity)
        return entity.queue
    end

    function queue:validate(entity)
        entity.queue = table.merge(require('game.components.queue')(), entity.queue)
        entity.queue.parent = entity
        return entity
    end

    function queue:update(dt, speed)
        game:scene().queue:update(dt, speed)
    end

    function queue:process(entity, dt, speed)
        entity.queue:update(dt, speed)
    end

	function queue:render(entity)
		if game.debugMode then
			local lc = love.graphics.getCanvas()
			love.graphics.setCanvas(game.layers.debug)
			outline_print(f("%i", #entity.queue.queue), math.floor(entity.x + game.camera.x), math.floor(entity.y + game.camera.y))
			love.graphics.setCanvas(lc)
		end
	end

    return queue
end
