--
--
--
--
--

return function()
	local stats = game.system()

	function stats:validate(entity)
		printf ("validating %s", entity.name)
		entity.stats = table.merge(require("game.components.stats")(), entity.stats)
		entity.stats.parent = entity
		return entity
	end

	function stats:filter(entity)
		return entity.stats
	end

	function stats:process(entity, dt, speed)
		for name, value in pairs(entity.stats.baseStats) do
			local boost = 1

			if entity.stats.boosts[name] == 1 then
				boost = 1.25
			elseif entity.stats.boosts[name] == 2 then
				boost = 2
			elseif entity.stats.boosts[name] == 3 then
				boost = 3.25
			elseif entity.stats.boosts[name] > 3 then
				boost = 5
			end

			local equipAdd = 0
			for equip, stats in pairs(entity.stats.equips) do
				if stats then
					equipAdd = equipAdd + stats[name]
				end
			end

			entity.stats[name] = (value + equipAdd) * boost
		end
	end

	function stats:render(entity)

	end

	return stats
end
